"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useBaseQuery = void 0;
const vue_1 = require("vue");
const useQueryClient_1 = require("./useQueryClient");
const utils_1 = require("./utils");
function useBaseQuery(options, Observer) {
    const queryClient = useQueryClient_1.useQueryClient();
    const observer = new Observer(queryClient, queryClient.defaultQueryObserverOptions(options));
    const state = vue_1.reactive(observer.getCurrentResult());
    const unsubscribe = observer.subscribe((result) => {
        utils_1.updateState(state, result);
    });
    vue_1.watchEffect(() => {
        observer.setOptions(queryClient.defaultQueryObserverOptions(options));
    });
    vue_1.onUnmounted(() => {
        unsubscribe();
    });
    return vue_1.toRefs(vue_1.readonly(state));
}
exports.useBaseQuery = useBaseQuery;
